#include "_gen/svc-call.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _tpy_svc_call_content_object_info;

struct _TpySvcCallContentClass {
    GTypeInterface parent_class;
    tpy_svc_call_content_remove_impl remove_cb;
};

enum {
    SIGNAL_CALL_CONTENT_Removed,
    SIGNAL_CALL_CONTENT_StreamsAdded,
    SIGNAL_CALL_CONTENT_StreamsRemoved,
    N_CALL_CONTENT_SIGNALS
};
static guint call_content_signals[N_CALL_CONTENT_SIGNALS] = {0};

static void tpy_svc_call_content_base_init (gpointer klass);

GType
tpy_svc_call_content_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallContentClass),
        tpy_svc_call_content_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallContent", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_content_remove (TpySvcCallContent *self,
    guint in_Reason,
    const gchar *in_Detailed_Removal_Reason,
    const gchar *in_Message,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_content_remove_impl impl = (TPY_SVC_CALL_CONTENT_GET_CLASS (self)->remove_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Reason,
        in_Detailed_Removal_Reason,
        in_Message,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_content_implement_remove (TpySvcCallContentClass *klass, tpy_svc_call_content_remove_impl impl)
{
  klass->remove_cb = impl;
}

void
tpy_svc_call_content_emit_removed (gpointer instance)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT));
  g_signal_emit (instance,
      call_content_signals[SIGNAL_CALL_CONTENT_Removed],
      0);
}

void
tpy_svc_call_content_emit_streams_added (gpointer instance,
    const GPtrArray *arg_Streams)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT));
  g_signal_emit (instance,
      call_content_signals[SIGNAL_CALL_CONTENT_StreamsAdded],
      0,
      arg_Streams);
}

void
tpy_svc_call_content_emit_streams_removed (gpointer instance,
    const GPtrArray *arg_Streams)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT));
  g_signal_emit (instance,
      call_content_signals[SIGNAL_CALL_CONTENT_StreamsRemoved],
      0,
      arg_Streams);
}

static inline void
tpy_svc_call_content_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[6] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "as", 0, NULL, NULL }, /* Interfaces */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* Name */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Type */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Disposition */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "ao", 0, NULL, NULL }, /* Streams */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_content_get_type (),
      &_tpy_svc_call_content_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Content.DRAFT");
  properties[0].name = g_quark_from_static_string ("Interfaces");
  properties[0].type = G_TYPE_STRV;
  properties[1].name = g_quark_from_static_string ("Name");
  properties[1].type = G_TYPE_STRING;
  properties[2].name = g_quark_from_static_string ("Type");
  properties[2].type = G_TYPE_UINT;
  properties[3].name = g_quark_from_static_string ("Disposition");
  properties[3].type = G_TYPE_UINT;
  properties[4].name = g_quark_from_static_string ("Streams");
  properties[4].type = dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH);
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_CONTENT, &interface);

  call_content_signals[SIGNAL_CALL_CONTENT_Removed] =
  g_signal_new ("removed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__VOID,
      G_TYPE_NONE,
      0);

  call_content_signals[SIGNAL_CALL_CONTENT_StreamsAdded] =
  g_signal_new ("streams-added",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));

  call_content_signals[SIGNAL_CALL_CONTENT_StreamsRemoved] =
  g_signal_new ("streams-removed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));

}
static void
tpy_svc_call_content_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_content_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_content_methods[] = {
  { (GCallback) tpy_svc_call_content_remove, _tpy_marshal_VOID__UINT_STRING_STRING_POINTER, 0 },
};

static const DBusGObjectInfo _tpy_svc_call_content_object_info = {
  0,
  _tpy_svc_call_content_methods,
  1,
"org.freedesktop.Telepathy.Call.Content.DRAFT\0Remove\0A\0Reason\0I\0u\0Detailed_Removal_Reason\0I\0s\0Message\0I\0s\0\0\0",
"org.freedesktop.Telepathy.Call.Content.DRAFT\0Removed\0org.freedesktop.Telepathy.Call.Content.DRAFT\0StreamsAdded\0org.freedesktop.Telepathy.Call.Content.DRAFT\0StreamsRemoved\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_content_codec_offer_object_info;

struct _TpySvcCallContentCodecOfferClass {
    GTypeInterface parent_class;
    tpy_svc_call_content_codec_offer_accept_impl accept_cb;
    tpy_svc_call_content_codec_offer_reject_impl reject_cb;
};

static void tpy_svc_call_content_codec_offer_base_init (gpointer klass);

GType
tpy_svc_call_content_codec_offer_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallContentCodecOfferClass),
        tpy_svc_call_content_codec_offer_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallContentCodecOffer", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_content_codec_offer_accept (TpySvcCallContentCodecOffer *self,
    const GPtrArray *in_Codecs,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_content_codec_offer_accept_impl impl = (TPY_SVC_CALL_CONTENT_CODEC_OFFER_GET_CLASS (self)->accept_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Codecs,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_content_codec_offer_implement_accept (TpySvcCallContentCodecOfferClass *klass, tpy_svc_call_content_codec_offer_accept_impl impl)
{
  klass->accept_cb = impl;
}

static void
tpy_svc_call_content_codec_offer_reject (TpySvcCallContentCodecOffer *self,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_content_codec_offer_reject_impl impl = (TPY_SVC_CALL_CONTENT_CODEC_OFFER_GET_CLASS (self)->reject_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_content_codec_offer_implement_reject (TpySvcCallContentCodecOfferClass *klass, tpy_svc_call_content_codec_offer_reject_impl impl)
{
  klass->reject_cb = impl;
}

static inline void
tpy_svc_call_content_codec_offer_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[4] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "as", 0, NULL, NULL }, /* Interfaces */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a(usuua{ss})", 0, NULL, NULL }, /* RemoteContactCodecs */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* RemoteContact */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_content_codec_offer_get_type (),
      &_tpy_svc_call_content_codec_offer_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Content.CodecOffer.DRAFT");
  properties[0].name = g_quark_from_static_string ("Interfaces");
  properties[0].type = G_TYPE_STRV;
  properties[1].name = g_quark_from_static_string ("RemoteContactCodecs");
  properties[1].type = (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID))));
  properties[2].name = g_quark_from_static_string ("RemoteContact");
  properties[2].type = G_TYPE_UINT;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_CONTENT_CODEC_OFFER, &interface);

}
static void
tpy_svc_call_content_codec_offer_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_content_codec_offer_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_content_codec_offer_methods[] = {
  { (GCallback) tpy_svc_call_content_codec_offer_accept, _tpy_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) tpy_svc_call_content_codec_offer_reject, g_cclosure_marshal_VOID__POINTER, 88 },
};

static const DBusGObjectInfo _tpy_svc_call_content_codec_offer_object_info = {
  0,
  _tpy_svc_call_content_codec_offer_methods,
  2,
"org.freedesktop.Telepathy.Call.Content.CodecOffer.DRAFT\0Accept\0A\0Codecs\0I\0a(usuua{ss})\0\0org.freedesktop.Telepathy.Call.Content.CodecOffer.DRAFT\0Reject\0A\0\0\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_content_interface_media_object_info;

struct _TpySvcCallContentInterfaceMediaClass {
    GTypeInterface parent_class;
    tpy_svc_call_content_interface_media_update_codecs_impl update_codecs_cb;
};

enum {
    SIGNAL_CALL_CONTENT_INTERFACE_MEDIA_CodecsChanged,
    SIGNAL_CALL_CONTENT_INTERFACE_MEDIA_NewCodecOffer,
    N_CALL_CONTENT_INTERFACE_MEDIA_SIGNALS
};
static guint call_content_interface_media_signals[N_CALL_CONTENT_INTERFACE_MEDIA_SIGNALS] = {0};

static void tpy_svc_call_content_interface_media_base_init (gpointer klass);

GType
tpy_svc_call_content_interface_media_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallContentInterfaceMediaClass),
        tpy_svc_call_content_interface_media_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallContentInterfaceMedia", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_content_interface_media_update_codecs (TpySvcCallContentInterfaceMedia *self,
    const GPtrArray *in_Codecs,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_content_interface_media_update_codecs_impl impl = (TPY_SVC_CALL_CONTENT_INTERFACE_MEDIA_GET_CLASS (self)->update_codecs_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Codecs,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_content_interface_media_implement_update_codecs (TpySvcCallContentInterfaceMediaClass *klass, tpy_svc_call_content_interface_media_update_codecs_impl impl)
{
  klass->update_codecs_cb = impl;
}

void
tpy_svc_call_content_interface_media_emit_codecs_changed (gpointer instance,
    GHashTable *arg_Updated_Codecs,
    const GArray *arg_Removed_Contacts)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_content_interface_media_signals[SIGNAL_CALL_CONTENT_INTERFACE_MEDIA_CodecsChanged],
      0,
      arg_Updated_Codecs,
      arg_Removed_Contacts);
}

void
tpy_svc_call_content_interface_media_emit_new_codec_offer (gpointer instance,
    guint arg_Contact,
    const gchar *arg_Offer,
    const GPtrArray *arg_Codecs)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_content_interface_media_signals[SIGNAL_CALL_CONTENT_INTERFACE_MEDIA_NewCodecOffer],
      0,
      arg_Contact,
      arg_Offer,
      arg_Codecs);
}

static inline void
tpy_svc_call_content_interface_media_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[4] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{ua(usuua{ss})}", 0, NULL, NULL }, /* ContactCodecMap */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "(oua(usuua{ss}))", 0, NULL, NULL }, /* CodecOffer */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Packetization */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_content_interface_media_get_type (),
      &_tpy_svc_call_content_interface_media_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Content.Interface.Media.DRAFT");
  properties[0].name = g_quark_from_static_string ("ContactCodecMap");
  properties[0].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID))))));
  properties[1].name = g_quark_from_static_string ("CodecOffer");
  properties[1].type = (dbus_g_type_get_struct ("GValueArray", DBUS_TYPE_G_OBJECT_PATH, G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))), G_TYPE_INVALID));
  properties[2].name = g_quark_from_static_string ("Packetization");
  properties[2].type = G_TYPE_UINT;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_MEDIA, &interface);

  call_content_interface_media_signals[SIGNAL_CALL_CONTENT_INTERFACE_MEDIA_CodecsChanged] =
  g_signal_new ("codecs-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))))),
      DBUS_TYPE_G_UINT_ARRAY);

  call_content_interface_media_signals[SIGNAL_CALL_CONTENT_INTERFACE_MEDIA_NewCodecOffer] =
  g_signal_new ("new-codec-offer",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__UINT_BOXED_BOXED,
      G_TYPE_NONE,
      3,
      G_TYPE_UINT,
      DBUS_TYPE_G_OBJECT_PATH,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))));

}
static void
tpy_svc_call_content_interface_media_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_content_interface_media_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_content_interface_media_methods[] = {
  { (GCallback) tpy_svc_call_content_interface_media_update_codecs, _tpy_marshal_VOID__BOXED_POINTER, 0 },
};

static const DBusGObjectInfo _tpy_svc_call_content_interface_media_object_info = {
  0,
  _tpy_svc_call_content_interface_media_methods,
  1,
"org.freedesktop.Telepathy.Call.Content.Interface.Media.DRAFT\0UpdateCodecs\0A\0Codecs\0I\0a(usuua{ss})\0\0\0",
"org.freedesktop.Telepathy.Call.Content.Interface.Media.DRAFT\0CodecsChanged\0org.freedesktop.Telepathy.Call.Content.Interface.Media.DRAFT\0NewCodecOffer\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_content_interface_mute_object_info;

struct _TpySvcCallContentInterfaceMuteClass {
    GTypeInterface parent_class;
    tpy_svc_call_content_interface_mute_set_muted_impl set_muted_cb;
};

enum {
    SIGNAL_CALL_CONTENT_INTERFACE_MUTE_MuteStateChanged,
    N_CALL_CONTENT_INTERFACE_MUTE_SIGNALS
};
static guint call_content_interface_mute_signals[N_CALL_CONTENT_INTERFACE_MUTE_SIGNALS] = {0};

static void tpy_svc_call_content_interface_mute_base_init (gpointer klass);

GType
tpy_svc_call_content_interface_mute_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallContentInterfaceMuteClass),
        tpy_svc_call_content_interface_mute_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallContentInterfaceMute", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_content_interface_mute_set_muted (TpySvcCallContentInterfaceMute *self,
    gboolean in_Muted,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_content_interface_mute_set_muted_impl impl = (TPY_SVC_CALL_CONTENT_INTERFACE_MUTE_GET_CLASS (self)->set_muted_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Muted,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_content_interface_mute_implement_set_muted (TpySvcCallContentInterfaceMuteClass *klass, tpy_svc_call_content_interface_mute_set_muted_impl impl)
{
  klass->set_muted_cb = impl;
}

void
tpy_svc_call_content_interface_mute_emit_mute_state_changed (gpointer instance,
    gboolean arg_MuteState)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_MUTE));
  g_signal_emit (instance,
      call_content_interface_mute_signals[SIGNAL_CALL_CONTENT_INTERFACE_MUTE_MuteStateChanged],
      0,
      arg_MuteState);
}

static inline void
tpy_svc_call_content_interface_mute_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* MuteState */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_content_interface_mute_get_type (),
      &_tpy_svc_call_content_interface_mute_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Content.Interface.Mute.DRAFT");
  properties[0].name = g_quark_from_static_string ("MuteState");
  properties[0].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_MUTE, &interface);

  call_content_interface_mute_signals[SIGNAL_CALL_CONTENT_INTERFACE_MUTE_MuteStateChanged] =
  g_signal_new ("mute-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOOLEAN,
      G_TYPE_NONE,
      1,
      G_TYPE_BOOLEAN);

}
static void
tpy_svc_call_content_interface_mute_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_content_interface_mute_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_content_interface_mute_methods[] = {
  { (GCallback) tpy_svc_call_content_interface_mute_set_muted, _tpy_marshal_VOID__BOOLEAN_POINTER, 0 },
};

static const DBusGObjectInfo _tpy_svc_call_content_interface_mute_object_info = {
  0,
  _tpy_svc_call_content_interface_mute_methods,
  1,
"org.freedesktop.Telepathy.Call.Content.Interface.Mute.DRAFT\0SetMuted\0A\0Muted\0I\0b\0\0\0",
"org.freedesktop.Telepathy.Call.Content.Interface.Mute.DRAFT\0MuteStateChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_content_interface_video_control_object_info;

struct _TpySvcCallContentInterfaceVideoControlClass {
    GTypeInterface parent_class;
};

enum {
    SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_KeyFrameRequested,
    SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_VideoResolutionChanged,
    SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_BitrateChanged,
    SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_FramerateChanged,
    SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_MTUChanged,
    N_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_SIGNALS
};
static guint call_content_interface_video_control_signals[N_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_SIGNALS] = {0};

static void tpy_svc_call_content_interface_video_control_base_init (gpointer klass);

GType
tpy_svc_call_content_interface_video_control_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallContentInterfaceVideoControlClass),
        tpy_svc_call_content_interface_video_control_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallContentInterfaceVideoControl", &info, 0);
    }

  return type;
}

void
tpy_svc_call_content_interface_video_control_emit_key_frame_requested (gpointer instance)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_VIDEO_CONTROL));
  g_signal_emit (instance,
      call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_KeyFrameRequested],
      0);
}

void
tpy_svc_call_content_interface_video_control_emit_video_resolution_changed (gpointer instance,
    const GValueArray *arg_NewResolution)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_VIDEO_CONTROL));
  g_signal_emit (instance,
      call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_VideoResolutionChanged],
      0,
      arg_NewResolution);
}

void
tpy_svc_call_content_interface_video_control_emit_bitrate_changed (gpointer instance,
    guint arg_NewBitrate)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_VIDEO_CONTROL));
  g_signal_emit (instance,
      call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_BitrateChanged],
      0,
      arg_NewBitrate);
}

void
tpy_svc_call_content_interface_video_control_emit_framerate_changed (gpointer instance,
    guint arg_NewFramerate)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_VIDEO_CONTROL));
  g_signal_emit (instance,
      call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_FramerateChanged],
      0,
      arg_NewFramerate);
}

void
tpy_svc_call_content_interface_video_control_emit_mtu_changed (gpointer instance,
    guint arg_NewMTU)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_VIDEO_CONTROL));
  g_signal_emit (instance,
      call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_MTUChanged],
      0,
      arg_NewMTU);
}

static inline void
tpy_svc_call_content_interface_video_control_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[6] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "(uu)", 0, NULL, NULL }, /* VideoResolution */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Bitrate */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Framerate */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* MTU */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* ManualKeyFrames */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_content_interface_video_control_get_type (),
      &_tpy_svc_call_content_interface_video_control_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Content.Interface.VideoControl.DRAFT");
  properties[0].name = g_quark_from_static_string ("VideoResolution");
  properties[0].type = (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID));
  properties[1].name = g_quark_from_static_string ("Bitrate");
  properties[1].type = G_TYPE_UINT;
  properties[2].name = g_quark_from_static_string ("Framerate");
  properties[2].type = G_TYPE_UINT;
  properties[3].name = g_quark_from_static_string ("MTU");
  properties[3].type = G_TYPE_UINT;
  properties[4].name = g_quark_from_static_string ("ManualKeyFrames");
  properties[4].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_CONTENT_INTERFACE_VIDEO_CONTROL, &interface);

  call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_KeyFrameRequested] =
  g_signal_new ("key-frame-requested",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__VOID,
      G_TYPE_NONE,
      0);

  call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_VideoResolutionChanged] =
  g_signal_new ("video-resolution-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)));

  call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_BitrateChanged] =
  g_signal_new ("bitrate-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_FramerateChanged] =
  g_signal_new ("framerate-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  call_content_interface_video_control_signals[SIGNAL_CALL_CONTENT_INTERFACE_VIDEO_CONTROL_MTUChanged] =
  g_signal_new ("m-tu-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

}
static void
tpy_svc_call_content_interface_video_control_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_content_interface_video_control_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_content_interface_video_control_methods[] = {
  { NULL, NULL, 0 }
};

static const DBusGObjectInfo _tpy_svc_call_content_interface_video_control_object_info = {
  0,
  _tpy_svc_call_content_interface_video_control_methods,
  0,
"\0",
"org.freedesktop.Telepathy.Call.Content.Interface.VideoControl.DRAFT\0KeyFrameRequested\0org.freedesktop.Telepathy.Call.Content.Interface.VideoControl.DRAFT\0VideoResolutionChanged\0org.freedesktop.Telepathy.Call.Content.Interface.VideoControl.DRAFT\0BitrateChanged\0org.freedesktop.Telepathy.Call.Content.Interface.VideoControl.DRAFT\0FramerateChanged\0org.freedesktop.Telepathy.Call.Content.Interface.VideoControl.DRAFT\0MTUChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_stream_object_info;

struct _TpySvcCallStreamClass {
    GTypeInterface parent_class;
    tpy_svc_call_stream_set_sending_impl set_sending_cb;
    tpy_svc_call_stream_request_receiving_impl request_receiving_cb;
};

enum {
    SIGNAL_CALL_STREAM_RemoteMembersChanged,
    SIGNAL_CALL_STREAM_LocalSendingStateChanged,
    N_CALL_STREAM_SIGNALS
};
static guint call_stream_signals[N_CALL_STREAM_SIGNALS] = {0};

static void tpy_svc_call_stream_base_init (gpointer klass);

GType
tpy_svc_call_stream_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallStreamClass),
        tpy_svc_call_stream_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallStream", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_stream_set_sending (TpySvcCallStream *self,
    gboolean in_Send,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_set_sending_impl impl = (TPY_SVC_CALL_STREAM_GET_CLASS (self)->set_sending_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Send,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_implement_set_sending (TpySvcCallStreamClass *klass, tpy_svc_call_stream_set_sending_impl impl)
{
  klass->set_sending_cb = impl;
}

static void
tpy_svc_call_stream_request_receiving (TpySvcCallStream *self,
    guint in_Contact,
    gboolean in_Receive,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_request_receiving_impl impl = (TPY_SVC_CALL_STREAM_GET_CLASS (self)->request_receiving_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Contact,
        in_Receive,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_implement_request_receiving (TpySvcCallStreamClass *klass, tpy_svc_call_stream_request_receiving_impl impl)
{
  klass->request_receiving_cb = impl;
}

void
tpy_svc_call_stream_emit_remote_members_changed (gpointer instance,
    GHashTable *arg_Updates,
    const GArray *arg_Removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM));
  g_signal_emit (instance,
      call_stream_signals[SIGNAL_CALL_STREAM_RemoteMembersChanged],
      0,
      arg_Updates,
      arg_Removed);
}

void
tpy_svc_call_stream_emit_local_sending_state_changed (gpointer instance,
    guint arg_State)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM));
  g_signal_emit (instance,
      call_stream_signals[SIGNAL_CALL_STREAM_LocalSendingStateChanged],
      0,
      arg_State);
}

static inline void
tpy_svc_call_stream_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[5] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "as", 0, NULL, NULL }, /* Interfaces */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{uu}", 0, NULL, NULL }, /* RemoteMembers */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* LocalSendingState */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* CanRequestReceiving */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_stream_get_type (),
      &_tpy_svc_call_stream_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Stream.DRAFT");
  properties[0].name = g_quark_from_static_string ("Interfaces");
  properties[0].type = G_TYPE_STRV;
  properties[1].name = g_quark_from_static_string ("RemoteMembers");
  properties[1].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT));
  properties[2].name = g_quark_from_static_string ("LocalSendingState");
  properties[2].type = G_TYPE_UINT;
  properties[3].name = g_quark_from_static_string ("CanRequestReceiving");
  properties[3].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_STREAM, &interface);

  call_stream_signals[SIGNAL_CALL_STREAM_RemoteMembersChanged] =
  g_signal_new ("remote-members-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT)),
      DBUS_TYPE_G_UINT_ARRAY);

  call_stream_signals[SIGNAL_CALL_STREAM_LocalSendingStateChanged] =
  g_signal_new ("local-sending-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

}
static void
tpy_svc_call_stream_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_stream_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_stream_methods[] = {
  { (GCallback) tpy_svc_call_stream_set_sending, _tpy_marshal_VOID__BOOLEAN_POINTER, 0 },
  { (GCallback) tpy_svc_call_stream_request_receiving, _tpy_marshal_VOID__UINT_BOOLEAN_POINTER, 67 },
};

static const DBusGObjectInfo _tpy_svc_call_stream_object_info = {
  0,
  _tpy_svc_call_stream_methods,
  2,
"org.freedesktop.Telepathy.Call.Stream.DRAFT\0SetSending\0A\0Send\0I\0b\0\0org.freedesktop.Telepathy.Call.Stream.DRAFT\0RequestReceiving\0A\0Contact\0I\0u\0Receive\0I\0b\0\0\0",
"org.freedesktop.Telepathy.Call.Stream.DRAFT\0RemoteMembersChanged\0org.freedesktop.Telepathy.Call.Stream.DRAFT\0LocalSendingStateChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_stream_endpoint_object_info;

struct _TpySvcCallStreamEndpointClass {
    GTypeInterface parent_class;
    tpy_svc_call_stream_endpoint_set_selected_candidate_impl set_selected_candidate_cb;
    tpy_svc_call_stream_endpoint_set_stream_state_impl set_stream_state_cb;
};

enum {
    SIGNAL_CALL_STREAM_ENDPOINT_RemoteCredentialsSet,
    SIGNAL_CALL_STREAM_ENDPOINT_RemoteCandidatesAdded,
    SIGNAL_CALL_STREAM_ENDPOINT_CandidateSelected,
    SIGNAL_CALL_STREAM_ENDPOINT_StreamStateChanged,
    N_CALL_STREAM_ENDPOINT_SIGNALS
};
static guint call_stream_endpoint_signals[N_CALL_STREAM_ENDPOINT_SIGNALS] = {0};

static void tpy_svc_call_stream_endpoint_base_init (gpointer klass);

GType
tpy_svc_call_stream_endpoint_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallStreamEndpointClass),
        tpy_svc_call_stream_endpoint_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallStreamEndpoint", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_stream_endpoint_set_selected_candidate (TpySvcCallStreamEndpoint *self,
    const GValueArray *in_Candidate,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_endpoint_set_selected_candidate_impl impl = (TPY_SVC_CALL_STREAM_ENDPOINT_GET_CLASS (self)->set_selected_candidate_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Candidate,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_endpoint_implement_set_selected_candidate (TpySvcCallStreamEndpointClass *klass, tpy_svc_call_stream_endpoint_set_selected_candidate_impl impl)
{
  klass->set_selected_candidate_cb = impl;
}

static void
tpy_svc_call_stream_endpoint_set_stream_state (TpySvcCallStreamEndpoint *self,
    guint in_State,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_endpoint_set_stream_state_impl impl = (TPY_SVC_CALL_STREAM_ENDPOINT_GET_CLASS (self)->set_stream_state_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_State,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_endpoint_implement_set_stream_state (TpySvcCallStreamEndpointClass *klass, tpy_svc_call_stream_endpoint_set_stream_state_impl impl)
{
  klass->set_stream_state_cb = impl;
}

void
tpy_svc_call_stream_endpoint_emit_remote_credentials_set (gpointer instance,
    const gchar *arg_Username,
    const gchar *arg_Password)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_ENDPOINT));
  g_signal_emit (instance,
      call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_RemoteCredentialsSet],
      0,
      arg_Username,
      arg_Password);
}

void
tpy_svc_call_stream_endpoint_emit_remote_candidates_added (gpointer instance,
    const GPtrArray *arg_Candidates)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_ENDPOINT));
  g_signal_emit (instance,
      call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_RemoteCandidatesAdded],
      0,
      arg_Candidates);
}

void
tpy_svc_call_stream_endpoint_emit_candidate_selected (gpointer instance,
    const GValueArray *arg_Candidate)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_ENDPOINT));
  g_signal_emit (instance,
      call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_CandidateSelected],
      0,
      arg_Candidate);
}

void
tpy_svc_call_stream_endpoint_emit_stream_state_changed (gpointer instance,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_ENDPOINT));
  g_signal_emit (instance,
      call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_StreamStateChanged],
      0,
      arg_state);
}

static inline void
tpy_svc_call_stream_endpoint_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[6] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "(ss)", 0, NULL, NULL }, /* RemoteCredentials */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a(usua{sv})", 0, NULL, NULL }, /* RemoteCandidates */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "(usua{sv})", 0, NULL, NULL }, /* SelectedCandidate */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* StreamState */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Transport */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_stream_endpoint_get_type (),
      &_tpy_svc_call_stream_endpoint_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT");
  properties[0].name = g_quark_from_static_string ("RemoteCredentials");
  properties[0].type = (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INVALID));
  properties[1].name = g_quark_from_static_string ("RemoteCandidates");
  properties[1].type = (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID))));
  properties[2].name = g_quark_from_static_string ("SelectedCandidate");
  properties[2].type = (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID));
  properties[3].name = g_quark_from_static_string ("StreamState");
  properties[3].type = G_TYPE_UINT;
  properties[4].name = g_quark_from_static_string ("Transport");
  properties[4].type = G_TYPE_UINT;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_STREAM_ENDPOINT, &interface);

  call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_RemoteCredentialsSet] =
  g_signal_new ("remote-credentials-set",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__STRING_STRING,
      G_TYPE_NONE,
      2,
      G_TYPE_STRING,
      G_TYPE_STRING);

  call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_RemoteCandidatesAdded] =
  g_signal_new ("remote-candidates-added",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))));

  call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_CandidateSelected] =
  g_signal_new ("candidate-selected",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)));

  call_stream_endpoint_signals[SIGNAL_CALL_STREAM_ENDPOINT_StreamStateChanged] =
  g_signal_new ("stream-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

}
static void
tpy_svc_call_stream_endpoint_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_stream_endpoint_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_stream_endpoint_methods[] = {
  { (GCallback) tpy_svc_call_stream_endpoint_set_selected_candidate, _tpy_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) tpy_svc_call_stream_endpoint_set_stream_state, g_cclosure_marshal_VOID__UINT_POINTER, 100 },
};

static const DBusGObjectInfo _tpy_svc_call_stream_endpoint_object_info = {
  0,
  _tpy_svc_call_stream_endpoint_methods,
  2,
"org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT\0SetSelectedCandidate\0A\0Candidate\0I\0(usua{sv})\0\0org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT\0SetStreamState\0A\0State\0I\0u\0\0\0",
"org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT\0RemoteCredentialsSet\0org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT\0RemoteCandidatesAdded\0org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT\0CandidateSelected\0org.freedesktop.Telepathy.Call.Stream.Endpoint.DRAFT\0StreamStateChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_call_stream_interface_media_object_info;

struct _TpySvcCallStreamInterfaceMediaClass {
    GTypeInterface parent_class;
    tpy_svc_call_stream_interface_media_set_credentials_impl set_credentials_cb;
    tpy_svc_call_stream_interface_media_add_candidates_impl add_candidates_cb;
    tpy_svc_call_stream_interface_media_candidates_prepared_impl candidates_prepared_cb;
};

enum {
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_LocalCandidatesAdded,
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_LocalCredentialsChanged,
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_RelayInfoChanged,
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_STUNServersChanged,
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_ServerInfoRetrieved,
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_EndpointsChanged,
    SIGNAL_CALL_STREAM_INTERFACE_MEDIA_PleaseRestartICE,
    N_CALL_STREAM_INTERFACE_MEDIA_SIGNALS
};
static guint call_stream_interface_media_signals[N_CALL_STREAM_INTERFACE_MEDIA_SIGNALS] = {0};

static void tpy_svc_call_stream_interface_media_base_init (gpointer klass);

GType
tpy_svc_call_stream_interface_media_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcCallStreamInterfaceMediaClass),
        tpy_svc_call_stream_interface_media_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcCallStreamInterfaceMedia", &info, 0);
    }

  return type;
}

static void
tpy_svc_call_stream_interface_media_set_credentials (TpySvcCallStreamInterfaceMedia *self,
    const gchar *in_Username,
    const gchar *in_Password,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_interface_media_set_credentials_impl impl = (TPY_SVC_CALL_STREAM_INTERFACE_MEDIA_GET_CLASS (self)->set_credentials_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Username,
        in_Password,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_interface_media_implement_set_credentials (TpySvcCallStreamInterfaceMediaClass *klass, tpy_svc_call_stream_interface_media_set_credentials_impl impl)
{
  klass->set_credentials_cb = impl;
}

static void
tpy_svc_call_stream_interface_media_add_candidates (TpySvcCallStreamInterfaceMedia *self,
    const GPtrArray *in_Candidates,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_interface_media_add_candidates_impl impl = (TPY_SVC_CALL_STREAM_INTERFACE_MEDIA_GET_CLASS (self)->add_candidates_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Candidates,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_interface_media_implement_add_candidates (TpySvcCallStreamInterfaceMediaClass *klass, tpy_svc_call_stream_interface_media_add_candidates_impl impl)
{
  klass->add_candidates_cb = impl;
}

static void
tpy_svc_call_stream_interface_media_candidates_prepared (TpySvcCallStreamInterfaceMedia *self,
    DBusGMethodInvocation *context)
{
  tpy_svc_call_stream_interface_media_candidates_prepared_impl impl = (TPY_SVC_CALL_STREAM_INTERFACE_MEDIA_GET_CLASS (self)->candidates_prepared_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_call_stream_interface_media_implement_candidates_prepared (TpySvcCallStreamInterfaceMediaClass *klass, tpy_svc_call_stream_interface_media_candidates_prepared_impl impl)
{
  klass->candidates_prepared_cb = impl;
}

void
tpy_svc_call_stream_interface_media_emit_local_candidates_added (gpointer instance,
    const GPtrArray *arg_Candidates)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_LocalCandidatesAdded],
      0,
      arg_Candidates);
}

void
tpy_svc_call_stream_interface_media_emit_local_credentials_changed (gpointer instance,
    const gchar *arg_Username,
    const gchar *arg_Password)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_LocalCredentialsChanged],
      0,
      arg_Username,
      arg_Password);
}

void
tpy_svc_call_stream_interface_media_emit_relay_info_changed (gpointer instance,
    const GPtrArray *arg_Relay_Info)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_RelayInfoChanged],
      0,
      arg_Relay_Info);
}

void
tpy_svc_call_stream_interface_media_emit_stun_servers_changed (gpointer instance,
    const GPtrArray *arg_Servers)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_STUNServersChanged],
      0,
      arg_Servers);
}

void
tpy_svc_call_stream_interface_media_emit_server_info_retrieved (gpointer instance)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_ServerInfoRetrieved],
      0);
}

void
tpy_svc_call_stream_interface_media_emit_endpoints_changed (gpointer instance,
    const GPtrArray *arg_Endpoints_Added,
    const GPtrArray *arg_Endpoints_Removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_EndpointsChanged],
      0,
      arg_Endpoints_Added,
      arg_Endpoints_Removed);
}

void
tpy_svc_call_stream_interface_media_emit_please_restart_ice (gpointer instance)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA));
  g_signal_emit (instance,
      call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_PleaseRestartICE],
      0);
}

static inline void
tpy_svc_call_stream_interface_media_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[8] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* Transport */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a(usua{sv})", 0, NULL, NULL }, /* LocalCandidates */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "(ss)", 0, NULL, NULL }, /* LocalCredentials */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a(sq)", 0, NULL, NULL }, /* STUNServers */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "aa{sv}", 0, NULL, NULL }, /* RelayInfo */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* HasServerInfo */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "ao", 0, NULL, NULL }, /* Endpoints */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_call_stream_interface_media_get_type (),
      &_tpy_svc_call_stream_interface_media_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT");
  properties[0].name = g_quark_from_static_string ("Transport");
  properties[0].type = G_TYPE_UINT;
  properties[1].name = g_quark_from_static_string ("LocalCandidates");
  properties[1].type = (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID))));
  properties[2].name = g_quark_from_static_string ("LocalCredentials");
  properties[2].type = (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INVALID));
  properties[3].name = g_quark_from_static_string ("STUNServers");
  properties[3].type = (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID))));
  properties[4].name = g_quark_from_static_string ("RelayInfo");
  properties[4].type = (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE))));
  properties[5].name = g_quark_from_static_string ("HasServerInfo");
  properties[5].type = G_TYPE_BOOLEAN;
  properties[6].name = g_quark_from_static_string ("Endpoints");
  properties[6].type = dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH);
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CALL_STREAM_INTERFACE_MEDIA, &interface);

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_LocalCandidatesAdded] =
  g_signal_new ("local-candidates-added",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))));

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_LocalCredentialsChanged] =
  g_signal_new ("local-credentials-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__STRING_STRING,
      G_TYPE_NONE,
      2,
      G_TYPE_STRING,
      G_TYPE_STRING);

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_RelayInfoChanged] =
  g_signal_new ("relay-info-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)))));

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_STUNServersChanged] =
  g_signal_new ("s-tu-nservers-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))));

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_ServerInfoRetrieved] =
  g_signal_new ("server-info-retrieved",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__VOID,
      G_TYPE_NONE,
      0);

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_EndpointsChanged] =
  g_signal_new ("endpoints-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));

  call_stream_interface_media_signals[SIGNAL_CALL_STREAM_INTERFACE_MEDIA_PleaseRestartICE] =
  g_signal_new ("please-restart-ic-e",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__VOID,
      G_TYPE_NONE,
      0);

}
static void
tpy_svc_call_stream_interface_media_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_call_stream_interface_media_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_call_stream_interface_media_methods[] = {
  { (GCallback) tpy_svc_call_stream_interface_media_set_credentials, _tpy_marshal_VOID__STRING_STRING_POINTER, 0 },
  { (GCallback) tpy_svc_call_stream_interface_media_add_candidates, _tpy_marshal_VOID__BOXED_POINTER, 104 },
  { (GCallback) tpy_svc_call_stream_interface_media_candidates_prepared, g_cclosure_marshal_VOID__POINTER, 206 },
};

static const DBusGObjectInfo _tpy_svc_call_stream_interface_media_object_info = {
  0,
  _tpy_svc_call_stream_interface_media_methods,
  3,
"org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0SetCredentials\0A\0Username\0I\0s\0Password\0I\0s\0\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0AddCandidates\0A\0Candidates\0I\0a(usua{sv})\0\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0CandidatesPrepared\0A\0\0\0",
"org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0LocalCandidatesAdded\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0LocalCredentialsChanged\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0RelayInfoChanged\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0STUNServersChanged\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0ServerInfoRetrieved\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0EndpointsChanged\0org.freedesktop.Telepathy.Call.Stream.Interface.Media.DRAFT\0PleaseRestartICE\0\0",
"\0\0",
};

static const DBusGObjectInfo _tpy_svc_channel_type_call_object_info;

struct _TpySvcChannelTypeCallClass {
    GTypeInterface parent_class;
    tpy_svc_channel_type_call_set_ringing_impl set_ringing_cb;
    tpy_svc_channel_type_call_accept_impl accept_cb;
    tpy_svc_channel_type_call_hangup_impl hangup_cb;
    tpy_svc_channel_type_call_add_content_impl add_content_cb;
};

enum {
    SIGNAL_CHANNEL_TYPE_CALL_ContentAdded,
    SIGNAL_CHANNEL_TYPE_CALL_ContentRemoved,
    SIGNAL_CHANNEL_TYPE_CALL_CallStateChanged,
    SIGNAL_CHANNEL_TYPE_CALL_CallMembersChanged,
    N_CHANNEL_TYPE_CALL_SIGNALS
};
static guint channel_type_call_signals[N_CHANNEL_TYPE_CALL_SIGNALS] = {0};

static void tpy_svc_channel_type_call_base_init (gpointer klass);

GType
tpy_svc_channel_type_call_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TpySvcChannelTypeCallClass),
        tpy_svc_channel_type_call_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TpySvcChannelTypeCall", &info, 0);
    }

  return type;
}

static void
tpy_svc_channel_type_call_set_ringing (TpySvcChannelTypeCall *self,
    DBusGMethodInvocation *context)
{
  tpy_svc_channel_type_call_set_ringing_impl impl = (TPY_SVC_CHANNEL_TYPE_CALL_GET_CLASS (self)->set_ringing_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_channel_type_call_implement_set_ringing (TpySvcChannelTypeCallClass *klass, tpy_svc_channel_type_call_set_ringing_impl impl)
{
  klass->set_ringing_cb = impl;
}

static void
tpy_svc_channel_type_call_accept (TpySvcChannelTypeCall *self,
    DBusGMethodInvocation *context)
{
  tpy_svc_channel_type_call_accept_impl impl = (TPY_SVC_CHANNEL_TYPE_CALL_GET_CLASS (self)->accept_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_channel_type_call_implement_accept (TpySvcChannelTypeCallClass *klass, tpy_svc_channel_type_call_accept_impl impl)
{
  klass->accept_cb = impl;
}

static void
tpy_svc_channel_type_call_hangup (TpySvcChannelTypeCall *self,
    guint in_Reason,
    const gchar *in_Detailed_Hangup_Reason,
    const gchar *in_Message,
    DBusGMethodInvocation *context)
{
  tpy_svc_channel_type_call_hangup_impl impl = (TPY_SVC_CHANNEL_TYPE_CALL_GET_CLASS (self)->hangup_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Reason,
        in_Detailed_Hangup_Reason,
        in_Message,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_channel_type_call_implement_hangup (TpySvcChannelTypeCallClass *klass, tpy_svc_channel_type_call_hangup_impl impl)
{
  klass->hangup_cb = impl;
}

static void
tpy_svc_channel_type_call_add_content (TpySvcChannelTypeCall *self,
    const gchar *in_Content_Name,
    guint in_Content_Type,
    DBusGMethodInvocation *context)
{
  tpy_svc_channel_type_call_add_content_impl impl = (TPY_SVC_CHANNEL_TYPE_CALL_GET_CLASS (self)->add_content_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Content_Name,
        in_Content_Type,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
tpy_svc_channel_type_call_implement_add_content (TpySvcChannelTypeCallClass *klass, tpy_svc_channel_type_call_add_content_impl impl)
{
  klass->add_content_cb = impl;
}

void
tpy_svc_channel_type_call_emit_content_added (gpointer instance,
    const gchar *arg_Content)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CHANNEL_TYPE_CALL));
  g_signal_emit (instance,
      channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_ContentAdded],
      0,
      arg_Content);
}

void
tpy_svc_channel_type_call_emit_content_removed (gpointer instance,
    const gchar *arg_Content)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CHANNEL_TYPE_CALL));
  g_signal_emit (instance,
      channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_ContentRemoved],
      0,
      arg_Content);
}

void
tpy_svc_channel_type_call_emit_call_state_changed (gpointer instance,
    guint arg_Call_State,
    guint arg_Call_Flags,
    const GValueArray *arg_Call_State_Reason,
    GHashTable *arg_Call_State_Details)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CHANNEL_TYPE_CALL));
  g_signal_emit (instance,
      channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_CallStateChanged],
      0,
      arg_Call_State,
      arg_Call_Flags,
      arg_Call_State_Reason,
      arg_Call_State_Details);
}

void
tpy_svc_channel_type_call_emit_call_members_changed (gpointer instance,
    GHashTable *arg_Flags_Changed,
    const GArray *arg_Removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPY_TYPE_SVC_CHANNEL_TYPE_CALL));
  g_signal_emit (instance,
      channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_CallMembersChanged],
      0,
      arg_Flags_Changed,
      arg_Removed);
}

static inline void
tpy_svc_channel_type_call_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[14] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "ao", 0, NULL, NULL }, /* Contents */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{sv}", 0, NULL, NULL }, /* CallStateDetails */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* CallState */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* CallFlags */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "(uus)", 0, NULL, NULL }, /* CallStateReason */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* HardwareStreaming */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{uu}", 0, NULL, NULL }, /* CallMembers */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* InitialTransport */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* InitialAudio */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* InitialVideo */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* InitialAudioName */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* InitialVideoName */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* MutableContents */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (tpy_svc_channel_type_call_get_type (),
      &_tpy_svc_channel_type_call_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.Call.DRAFT");
  properties[0].name = g_quark_from_static_string ("Contents");
  properties[0].type = dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH);
  properties[1].name = g_quark_from_static_string ("CallStateDetails");
  properties[1].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE));
  properties[2].name = g_quark_from_static_string ("CallState");
  properties[2].type = G_TYPE_UINT;
  properties[3].name = g_quark_from_static_string ("CallFlags");
  properties[3].type = G_TYPE_UINT;
  properties[4].name = g_quark_from_static_string ("CallStateReason");
  properties[4].type = (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_INVALID));
  properties[5].name = g_quark_from_static_string ("HardwareStreaming");
  properties[5].type = G_TYPE_BOOLEAN;
  properties[6].name = g_quark_from_static_string ("CallMembers");
  properties[6].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT));
  properties[7].name = g_quark_from_static_string ("InitialTransport");
  properties[7].type = G_TYPE_STRING;
  properties[8].name = g_quark_from_static_string ("InitialAudio");
  properties[8].type = G_TYPE_BOOLEAN;
  properties[9].name = g_quark_from_static_string ("InitialVideo");
  properties[9].type = G_TYPE_BOOLEAN;
  properties[10].name = g_quark_from_static_string ("InitialAudioName");
  properties[10].type = G_TYPE_STRING;
  properties[11].name = g_quark_from_static_string ("InitialVideoName");
  properties[11].type = G_TYPE_STRING;
  properties[12].name = g_quark_from_static_string ("MutableContents");
  properties[12].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (TPY_TYPE_SVC_CHANNEL_TYPE_CALL, &interface);

  channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_ContentAdded] =
  g_signal_new ("content-added",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      DBUS_TYPE_G_OBJECT_PATH);

  channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_ContentRemoved] =
  g_signal_new ("content-removed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      DBUS_TYPE_G_OBJECT_PATH);

  channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_CallStateChanged] =
  g_signal_new ("call-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__UINT_UINT_BOXED_BOXED,
      G_TYPE_NONE,
      4,
      G_TYPE_UINT,
      G_TYPE_UINT,
      (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_INVALID)),
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  channel_type_call_signals[SIGNAL_CHANNEL_TYPE_CALL_CallMembersChanged] =
  g_signal_new ("call-members-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpy_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT)),
      DBUS_TYPE_G_UINT_ARRAY);

}
static void
tpy_svc_channel_type_call_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpy_svc_channel_type_call_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpy_svc_channel_type_call_methods[] = {
  { (GCallback) tpy_svc_channel_type_call_set_ringing, g_cclosure_marshal_VOID__POINTER, 0 },
  { (GCallback) tpy_svc_channel_type_call_accept, g_cclosure_marshal_VOID__POINTER, 64 },
  { (GCallback) tpy_svc_channel_type_call_hangup, _tpy_marshal_VOID__UINT_STRING_STRING_POINTER, 124 },
  { (GCallback) tpy_svc_channel_type_call_add_content, _tpy_marshal_VOID__STRING_UINT_POINTER, 234 },
};

static const DBusGObjectInfo _tpy_svc_channel_type_call_object_info = {
  0,
  _tpy_svc_channel_type_call_methods,
  4,
"org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0SetRinging\0A\0\0org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0Accept\0A\0\0org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0Hangup\0A\0Reason\0I\0u\0Detailed_Hangup_Reason\0I\0s\0Message\0I\0s\0\0org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0AddContent\0A\0Content_Name\0I\0s\0Content_Type\0I\0u\0Content\0O\0F\0N\0o\0\0\0",
"org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0ContentAdded\0org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0ContentRemoved\0org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0CallStateChanged\0org.freedesktop.Telepathy.Channel.Type.Call.DRAFT\0CallMembersChanged\0\0",
"\0\0",
};


